#!/bin/bash
# Installation patch for the Borealis superkaramba theme ver.1.0
# Copyright 2004 - Ivica Ico Bukvic
# http://meowing.ccm.uc.edu/~ico/
# This install script is made available under GPL license
# For more info regarding this license, please see http://www.gnu.org/copyleft/gpl.html
#==============================================================

#Let's see if we are root
if [ `id -u` -ne 0 ]
then
  echo "You must be superuser (su) to run this script. Also, it is advisable to not run this script directly, but rather through the main install.sh script found in the Karamba/Borealis/ directory."
  exit 1
fi

kde_script=`which startkde`
echo "...Creating backup ${kde_script}.old"
cp $kde_script ${kde_script}.old
echo "...Patching $kde_script"
cat $kde_script | sed -e 's/artsshell -q terminate/artsshell -q terminate\nkillall 3ddeskd/' > tmp
mv -f tmp $kde_script
chmod 755 $kde_script
echo "...OK. Now type 'exit' to proceed"

exit 0
