

import karamba
import string
import os
import time
import XBarUtils


## Coords
widgetX = 0
widgetY = 0
widgetWidth = 1024
widgetHeight = 25

## Background bar
barImageCenter = 0
barImageLeft= 0
barImageRight = 0
barImageFile = "bar_center.png"
barImageFileLeft = "bar_left.png"
barImageFileRight = "bar_right.png"

## Apple menu
appleIcon =0
appleIconFile = "apple.png"
appleX = 10
appleY = 0
appleWidth = 22
appleHeight = 22

## Loging Menu
loginMenu =0
loginPop=0
loginPopX=50
loginPopY=22
loginX = 50
loginY = 0
loginWidth = 100
loginHeight = 22

## TaskList
taskMenuIconFile = "find.png"
taskMenuIcon= 0
taskMenuIconX= 1000
taskMenuIconY= 0

taskPop = 0
taskPopNew = 0
taskPopX = 1000
taskPopY = 22

## Clock
textClock = 0
xClock = 0
yClock = 0

## Configurations stuff
themePath = 0

configurations = {
	"configurationFile"	: "osx_menubar.conf",
	"version"		: "0.2",
	"cfg"		:"osxmenu.conf",
	"iconsPath"		: "/icons/",
	"barsPath"		: "/bars/",
	"barTheme"		:"",
	"imgIcons"		: [],
	"cmdIcons"		: [],
	"typeMenu"		: [],

}

xMenuIcons=0
yMenuIcons=0
countMenuIcons=0
spaceMenuIcons=5
sizeMenuIcons=22
imgMenuIcons=[]
cmdMenuIcons=[]

countMenu=0
xMenu=40
yMenu=2
fontMenu="Macintosh"
sizeMenu=18
menuMenu=[]
barMenu=[]
zoneMenu=[]
cmdidMenu=[]
cmdMenu=[]

taskTask=[]
taskID=[]

## Create Clock
def XMBAddClock(widget):
	global xClock
	global yClock
	global widgetWidth
	global textClock
	global xMenuIcons
	global fontMenu

	SizeClock=160

	xClock=widgetWidth-SizeClock-30
	yClock=2

	textClock=karamba.createText(widget,xClock,yClock,SizeClock,25,"")
	karamba.changeTextFont(widget, textClock,fontMenu)
	karamba.changeTextColor(widget, textClock, 0,0,0)
	xMenuIcons =xClock-30

def XMBClickFindMenu(widget,x,y,z):
	for i in range(len(zoneMenu)):
		if(x<zoneMenu[i]):
			## Found the Menu, we will popup it
			if(i==0):
				karamba.popupMenu(widget,menuMenu[i],40,20)
			else:
				karamba.popupMenu(widget,menuMenu[i],zoneMenu[i-1],20)
			return


def XMBSensorAddEmails(widget,menuType):
	print "getting Emails accounts"
	accountsfile=os.popen("dcop kmail KMailIface accounts","r")
	while 1:
		MountLine=accountsfile.readline()
		if len(MountLine) == 0:
			break
		MountLine=MountLine.strip()
		XMBAddMenu(widget,"Check Email on " + MountLine,menuType,"kmail","dcop kmail KMailIface checkAccount " + MountLine)




## Add Menus
def XMBAddMenu(widget,menuName,menuType,menuIcon,menuCommand):
	global themePath
	global configurations
	global countMenu
	global xMenu
	global yMenu
	global fontMenu
	global sizeMenu
	global widgetHeight
	if(menuType==-1):
		menuMenu.append(karamba.createMenu(widget))
		##karamba.addMenuItem(widget, menuMenu[countMenu], menuName, menuIcon)
		barMenu.append(karamba.createText(widget,xMenu,yMenu,len(menuName)*(sizeMenu/2.0)+5,widgetHeight,menuName))
		karamba.changeTextFont(widget, barMenu[countMenu], fontMenu)
		##karamba.changeTextColor(widget, barMenu[countMenu], 0,0,0)
		karamba.changeTextShadow(widget, barMenu[countMenu], 1)
		zoneMenu.append(xMenu+len(menuName)*(sizeMenu/2.0)+5)
		cmdidMenu.append([])
		cmdMenu.append([])
		xMenu=xMenu+10+len(menuName)*(sizeMenu/2.0)
		countMenu=countMenu+1
	else:
		cmdidMenu[menuType].append(karamba.addMenuItem(widget, menuMenu[menuType], menuName, themePath+ configurations["iconsPath"]  + menuIcon+".png"))
		cmdMenu[menuType].append(menuCommand)

def XMBAddMenus(widget):
	for i in range(len(configurations["typeMenu"])):
		if(configurations["typeMenu"][i]=="finder"):
			XMBAddMenu(widget,"Finder",-1,"finder","kfind &")
			XMBAddMenu(widget,"Find files...",i,"kfind","kfind &")
		elif(configurations["typeMenu"][i]=="file"):
			XMBAddMenu(widget,"File",-1,"finder","konqueror")
			XMBAddMenu(widget,"New Text File..",i,"write","kwrite &")
		elif(configurations["typeMenu"][i]=="view"):
			XMBAddMenu(widget,"View",-1,"view","konqueror")
			for d in range(configurations["numVirtualDesktop"]):
				XMBAddMenu(widget,"Go to Desktop " + str(d+1),i,str(d+1),"dcop kwin KWinInterface setCurrentDesktop " +str(d+1) +" &")
		elif(configurations["typeMenu"][i]=="go"):
			XMBAddMenu(widget,"Go",-1,"go","konqueror &")
			XMBAddMenu(widget,"Home",i,"home","konqueror &")
			XMBAddMenu(widget,"Internet",i,"konqueror","konqueror &")
			XMBAddMenu(widget,"E-Mail",i,"kmail","kmail &")
			XMBAddMenu(widget,"Downloads",i,"kget","kget &")
			XMBAddMenu(widget,"Browse Networks",i,"network","konqueror lan://localhost &")
			XMBAddMenu(widget,"Console",i,"konsole","konsole &")
		elif(configurations["typeMenu"][i]=="message"):
			XMBAddMenu(widget,"Message",-1,"message","konqueror")
			XMBAddMenu(widget,"E-Mail",i,"kmail","kmail &")
			XMBSensorAddEmails(widget,i)
			XMBAddMenu(widget,"Check all Accounts",i,"kmail","dcop kmail KMailIface  checkMail &")
		elif(configurations["typeMenu"][i]=="bookmarks"):
			XMBAddMenu(widget,"Bookmarks",-1,"bookmarks","konqueror")
			XMBAddMenu(widget,"Home",i,"home","konqueror &")
			XMBAddMenu(widget,"XIA Projects 2003",i,"help","konqueror http://www.xiaprojects.com &")
		elif(configurations["typeMenu"][i]=="media"):
			XMBAddMenu(widget,"Media",-1,"media","konqueror")
			XMBAddMenu(widget,"Play  XMMS",i,"xmms","xmms -p &")
			XMBAddMenu(widget,"Play",i,"play","dcop noatun Noatun play &")
			XMBAddMenu(widget,"Stop",i,"stop","dcop noatun Noatun stop &")
			XMBAddMenu(widget,"Pause",i,"pause","dcop noatun Noatun playpause &")
			XMBAddMenu(widget,"Previous",i,"prev","dcop noatun Noatun back &")
			XMBAddMenu(widget,"Next",i,"next","dcop noatun Noatun forward &")
		elif(configurations["typeMenu"][i]=="login"):
			XMBAddMenu(widget,"Login",-1,"login","konqueror")
			XMBAddMenu(widget,"Lock Screen",i,"lock","dcop kdesktop KScreensaverIface lock &")
			XMBAddMenu(widget,"Logout...",i,"exit","dcop ksmserver ksmserver logout 0, 0, 0 &")
		elif(configurations["typeMenu"][i]=="help"):
			XMBAddMenu(widget,"Help",-1,"help","khelpcenter &")
			XMBAddMenu(widget,"About",i,"help","konqueror http://www.xiaprojects.com/www/prodotti/osxmenu/main.php &")
			XMBAddMenu(widget,"Help",i,"help","khelpcenter &")
		elif(configurations["typeMenu"][i]=="programs"):
			XMBAddMenu(widget,"K",-1,"kde","khelpcenter &")
			XMBAddMenu(widget,"About",i,"help","konqueror http://www.xiaprojects.com/www/prodotti/osxmenu/main.php &")
		else:
			print configurations["typeMenu"][i] + " not implemented"

def menuItemClicked(widget,Ilmenu,command):
	global taskPop
	for i in range(len(menuMenu)):
		if(menuMenu[i]==Ilmenu):
			for c in range(len(cmdidMenu[i])):
				if(cmdidMenu[i][c]==command):
					print "trovato"
					os.system(cmdMenu[i][c])
	if(taskPop==Ilmenu):
		print len(taskID)
		for i in range(len(taskID)):
			if(taskID[i]==command):
				karamba.performTaskAction(widget,taskTask[i],6)



## Update Clock
def XMBClockUpdate(widget):
	karamba.changeText(widget,textClock,time.strftime("%a %H:%M %d.%m.%Y") )

## Add Icon
def XMBAddIcon(widget,nameicon,command):
	global countMenuIcons
	global xMenuIcons
	global yMenuIcons
	global countMenuIcons
	global spaceMenuIcons
	global sizeMenuIcons
	ThisImage=(karamba.createImage(widget, xMenuIcons- (countMenuIcons)*(sizeMenuIcons+spaceMenuIcons), yMenuIcons,themePath+ configurations["iconsPath"]  + nameicon+".png"))
	if(ThisImage!=0):
		imgMenuIcons.append(ThisImage)
		karamba.createClickArea(widget,xMenuIcons- (countMenuIcons)*(sizeMenuIcons+spaceMenuIcons), yMenuIcons,22,22,command)
		countMenuIcons=countMenuIcons+1
		cmdMenuIcons.append(command)
		print "Icon Added"

## Load Icon Configuration
def XMBAddIcons(widget):
	for i in range(len(configurations["imgIcons"])):
		XMBAddIcon(widget,configurations["imgIcons"][i],configurations["cmdIcons"][i])

## Initialization
def initWidget(widget):
	global themePath
	global configurations
	global appleIcon
	global appleX
	global appleY
	global appleIconFile
	global widgetX
	global widgetY
	global loginX
	global loginY
	global loginMenu
	global loginPop
	global taskMenuIcon
	global taskMenuIconFile
	global taskMenuIconX
	global taskMenuIconY
	global barImageFile
	global barImageFileLeft
	global barImageFileRight
	global barImageRight
	global barImageCenter
	global barImageLeft



	## Configurations
	print "setup..."
	themePath = karamba.getThemePath(widget)
	print "Load Configuration..."
	XBarUtils.XBarReadCfg(themePath+configurations["cfg"],configurations)
	print "Path Icons: " + themePath+configurations["iconsPath"]

	## Load CFG
	print "loading configurations..."

	## Init components
	print "initializations..."

	## Menu

	## Init GUI
	print "gui..."
	print themePath+ configurations["barsPath"] + configurations["barTheme"]+"/"+ barImageFile
	## Bar Images
	barImageCenter=(karamba.createImage(widget, 10, 0,themePath+ configurations["barsPath"] + configurations["barTheme"]+"/"+ barImageFile))
	barImageRight=(karamba.createImage(widget, widgetWidth-10, 0,themePath+ configurations["barsPath"] + configurations["barTheme"]+"/"+ barImageFileRight))
	barImageLeft=(karamba.createImage(widget, 0, 0,themePath+ configurations["barsPath"] + configurations["barTheme"]+"/"+ barImageFileLeft))
	## The kMenu
	appleIcon=(karamba.createImage(widget, appleX, appleY,themePath+ configurations["iconsPath"]  + appleIconFile))

	taskMenuIcon=(karamba.createImage(widget, taskMenuIconX, taskMenuIconY,themePath+ configurations["iconsPath"]  + taskMenuIconFile))
	taskPop=karamba.createMenu(widget)


	## Show gui
	print "stuff..."
	karamba.resizeImage(widget,barImageCenter,widgetWidth-(10*2),25)
	karamba.resizeWidget(widget, widgetWidth, widgetHeight)
	karamba.moveWidget(widget, widgetX, widgetY)
	print "ready..."
	XMBAddClock(widget)
	XMBAddIcons(widget)
	XMBAddMenus(widget)

def widgetUpdated(widget):
	global taskPop
	global taskPopNew
	print "update..."
	XMBClockUpdate(widget)



###############################################################################
##  Function:
##    widgetMouseMoved(widget, x, y, button)
##
##  This gets called everytime the mouse is moved over our widget
##  Notes
##    widget = reference to our widget
##    x = x position (relative to our widget)
##    y = y position (relative to our widget)
##    botton = button being held:
##                    0 = No Mouse Button
##                    1 = Left Mouse Button
##                    2 = Middle Mouse Button
##                    3 = Right Mouse Button, but this will never happen
##                        because the right mouse button brings up the
##                        Karamba menu.
###############################################################################
def widgetMouseMoved(widget, x, y, button):
	print "move"

###############################################################################
##  Function:
##    widgetClicked(widget, x, y, button)
##
##  This gets called everytime our widget is clicked.
##  Notes:
##    widget = reference to our widget
##    x = x position (relative to our widget)
##    y = y position (relative to our widget)
##    botton = button clicked:
##                    1 = Left Mouse Button
##                    2 = Middle Mouse Button
##                    3 = Right Mouse Button, but this will never happen
##                        because the right mouse button brings up the
##                        Karamba menu.
###############################################################################
def widgetClicked(widget, x, y, button):
	global loginPop
	global loginPopX
	global loginPopY
	global taskPop
	global taskPopX
	global taskPopY
	global taskPopNew
	global taskID
	global taskTask


	karamba.deleteMenu(widget,taskPopNew)
	taskPopNew=karamba.createMenu(widget)

	TaskList = karamba.getTaskList(widget)
	taskID=[]
	taskTask=[]
	## Selecting ony of all process
	for task in TaskList:
		## getting task informations
		TaskName = karamba.getTaskInfo(widget, task)[2]
		TaskWindow = karamba.getTaskInfo(widget, task)[0]
		taskTask.append(task)
		taskID.append(karamba.addMenuItem(widget,taskPopNew,TaskWindow,configurations["taskIconsPath"]  + TaskName+ ".png"))
	taskPop=taskPopNew
	print "click"
	if(x>taskPopX):
		karamba.popupMenu(widget,taskPop,taskPopX,taskPopY)
		return
	if(x<40):
		os.system("dcop kicker kicker popupKMenu 0")
		return
	XMBClickFindMenu(widget,x,y,button)

def widgetClose(widget):
	## this will be called when we close
	print "close."


print "osX Menu Bar starting up..."
print "version " + configurations["version"]
