#this import statement allows access to the karamba functions
import karamba
import time
import string
import glob
import os
import os.path


ww=200
wh=200
oldDesk=0
linkfilesPath = "pics/"


#this is called when you widget is initialized
def initWidget(widget):
    global jl,oh,hl,thh,tmp,arrow_name,arrow_min_name,arrow_hour_name,linkfilesPath
    linkfilesPath=(karamba.getThemePath(widget)+ "pics/")

    arrow_min_name="pics/rome_min_hand.png"
    arrow_hour_name="pics/rome_hour_hand.png"
    arrow_name="pics/r_sec_hand.png"
    arrow_img=0;
    bg_name="pics/face_romes.png"
    karamba.addMenuConfigOption(widget,"face","Select face")
    karamba.setMenuConfigOption(widget, "face", "1")
    karamba.addMenuConfigOption(widget,"hand","Select hand")

    karamba.setMenuConfigOption(widget, "hand", "1")
    tmp=karamba.createImage(widget,0,0,bg_name)
    getconf(widget)

    w=ww#karamba.getImageWidth(widget,tmp);
    h=wh#karamba.getImageHeight(widget,tmp);
    karamba.resizeImageSmooth(widget,tmp,w,h)
    karamba.moveImage(widget,tmp,(ww-w)/2,(wh-h)/2)
    karamba.redrawWidget(widget);

    


    print "init\n"

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    global arrow_hour_name,arrow_min_name,arrow_name,tmp
    global oldDesk
    theSec = karamba.readConfigEntry(widget,"sec")
    arrow_min=karamba.createImage(widget,0,0,arrow_min_name)
    arrow_hour=karamba.createImage(widget,0,0,arrow_hour_name)
    arrow_img=karamba.createImage(widget,0,0,arrow_name)
    now = time.localtime(time.time())
    sec=now[5];
    min=now[4];
    hour=now[3];
    #    karamba.resizeImageSmooth(widget,arrow_img,ww,wh)
    karamba.rotateImage(widget,arrow_img,6*sec)
    karamba.rotateImage(widget,arrow_min,6*min)
    karamba.rotateImage(widget,arrow_hour,30*hour+min/2)

    w=karamba.getImageWidth(widget,arrow_img)
    h=karamba.getImageHeight(widget,arrow_img)
    karamba.moveImage(widget,arrow_img,(ww-w)/2,(wh-h)/2)
    #
    w=karamba.getImageWidth(widget,arrow_min)
    h=karamba.getImageHeight(widget,arrow_min)
    karamba.moveImage(widget,arrow_min,(ww-w)/2,(wh-h)/2)
    #
    w=karamba.getImageWidth(widget,arrow_hour)
    h=karamba.getImageHeight(widget,arrow_hour)
    karamba.moveImage(widget,arrow_hour,(ww-w)/2,(wh-h)/2)
    #
    karamba.redrawWidget(widget)
    #
    karamba.deleteImage(widget,arrow_img)
    karamba.deleteImage(widget,arrow_min)
    karamba.deleteImage(widget,arrow_hour)
    #print KWin.currentDesktop()
    


def widgetClicked(widget, x, y, button):
    pass
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass
def menuOptionChanged(widget, key, value):
	#themecommand = ["kdialog", "--title", "Theme Selector", "--radiolist", "Please select a theme to use:"]
	global facepid,handpid,isback,theback,thehand
	nkey=[]
	theList(widget)
	facepid= None
	handpid= None
	for i in range(len(jl)):
		jl[i] = jl[i].replace('</loc>', '')
		backface = ["kdialog", "--title", "Face Selector", "--radiolist", "Please select your Face from the list:"]
		for i in range(len(jl)):
			backface.append(jl[i])
			backface.append(jl[i])
			if theback == jl[i]:
				backface.append("on")
			else:
				backface.append("off")
		#theme = karamba.executeInteractive(widget, backface)
	if (key == "face"):
		facepid = karamba.executeInteractive(widget, backface)
		karamba.setMenuConfigOption(widget, "face", "0")
	for i in range(len(hl)):
		hl[i] = hl[i].replace('</loc>', '')
		handcommand = ["kdialog", "--title", "hand Selector", "--radiolist", "Please select your hands from the list:"]
		for i in range(len(hl)):
			handcommand.append(hl[i])
			handcommand.append(hl[i])
			if thehand == hl[i]:
				handcommand.append("on")
			else:
				handcommand.append("off")
		#theme = karamba.executeInteractive(widget, backface)
	if (key == "hand"):
		handpid = karamba.executeInteractive(widget, handcommand)
		karamba.setMenuConfigOption(widget, "hand", "0")

def commandOutput(widget, pid, output):
    global facepid, tmp,arrow_hour_name,handpid,arrow_min_name,arrow_name
    global theback,thehand
    #print output
    if pid == facepid:
    	theback = output.replace('\n','')
        #print theback
        karamba.writeConfigEntry(widget, "face", theback)
        karamba.deleteImage(widget,tmp)
        bg_name="pics/face_" +theback+ ".png"
        tmp=karamba.createImage(widget,0,0,bg_name)


    elif pid == handpid:
        thehand = output.replace('\n','')
        
        karamba.writeConfigEntry(widget, "hand", thehand)

        arrow_name="pics/" +thehand+ "_sec_hand.png"
        arrow_min_name="pics/" +thehand+ "_min_hand.png"
        arrow_hour_name="pics/" +thehand+ "_hour_hand.png"
        #arrow_hour=karamba.createImage(widget,0,0,arrow_hour_name)
       
        #karamba.redrawWidget(widget);
def getconf(widget):
    global  tmp,arrow_hour_name,handpid,arrow_min_name,arrow_name,theback,thehand
    theback = None
    theback = karamba.readConfigEntry(widget,"face")
    if theback == None:
        tmp=karamba.createImage(widget,0,0,"pics/face_romes.png")
    else:
    	karamba.deleteImage(widget,tmp)
        tmp=karamba.createImage(widget,0,0,"pics/face_" +theback+ ".png")
        #isback="pics/face_" +theback+ ".png"

    thehand = None
    thehand = karamba.readConfigEntry(widget,"hand")
    if thehand == None:
           arrow_min_name="pics/rome_min_hand.png"
	   arrow_hour_name="pics/rome_hour_hand.png"
	   arrow_name="pics/rome_sec_hand.png"
    else:
        arrow_name="pics/" +thehand+ "_sec_hand.png"
        arrow_min_name="pics/" +thehand+ "_min_hand.png"
        arrow_hour_name="pics/" +thehand+ "_hour_hand.png"

def theList(widget):
    global jl,oh,hl
    hl=[]
    jl=[]
    oh=0

    faceList = glob.glob(linkfilesPath+"face*")
    faceList.sort()
    handList = glob.glob(linkfilesPath+"*hand*")
    handList.sort()
   # print  glob.glob(linkfilesPath)
    length=len(faceList)
    for t in range(length):
        j=string.split(faceList[t],"/")
        jp=len(j)
        j=string.split(j[jp-1],"_")
        #print j
        j=string.split(j[1],".")
        jl.append(j[0])
    length = len(handList)
    for t in range(length):
        h=string.split(handList[t],"/")
        hp=len(h)
        h=string.split(h[hp-1],"_")
        if (h[0] <> oh):
            hl.append(h[0])
        oh=h[0]
        #print jl


# This will be printed when the widget loads.
print "Loaded my python extension!"

