# This is a redesign of the fabolous TubeClock widget for SuperKaramba
# I have only rescaled and altered it to fit my own widget for embedding 
# Batteri 

import karamba
import os

imageFiles = [
  "image/1-0.png",
  "image/1-1.png",
  "image/1-2.png",
  "image/1-3.png",
  "image/1-4.png",
  "image/1-5.png",
  "image/1-6.png",
  "image/1-7.png",
  "image/1-8.png",
  "image/1-9.png",
]
h1 = [0,0,0,0,0,0,0,0,0,0]
h2 = [0,0,0,0,0,0,0,0,0,0]
m1 = [0,0,0,0,0,0,0,0,0,0]
m2 = [0,0,0,0,0,0,0,0,0,0]
s1 = [0,0,0,0,0,0,0,0,0,0]
s2 = [0,0,0,0,0,0,0,0,0,0]
image = 0
init = 0
tooltip = ""
token = [ ]
oh1 = 0
oh2 = 0
om1 = 0
om2 = 0
os1 = 0
os2 = 0
xoffset =  12
yoffset =   7
woffset = 140

def initWidget(widget):
	pass

def widgetUpdated(widget):
	global token
	global init
	global image
	global h1
	global h2
	global m1
	global m2
	global s1
	global s2
	global oh1
	global oh2
	global om1
	global om2
	global os1
	global os2
	global tooltip
	if init == 0:
		for i in range(3):
			h1[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		for i in range(10):
			h2[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		for i in range(10):
			m1[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		for i in range(10):
			m2[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		for i in range(10):
			s1[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		for i in range(10):
			s2[i] = karamba.createImage(widget, woffset, woffset, imageFiles[i])
		init = 1
	else:
#		tooltip = 
		f = os.popen("/bin/date +%H:%M:%S")
		output = f.read()
		
		karamba.moveImage(widget, h1[int(oh1)], woffset, woffset)
		karamba.moveImage(widget, h1[int(output[0])],  0+xoffset, yoffset)
		oh1 = output[0]
		
		karamba.moveImage(widget, h2[int(oh2)], woffset, woffset)
		karamba.moveImage(widget, h2[int(output[1])], 18+xoffset, yoffset)
		oh2 = output[1]
		
		karamba.moveImage(widget, m1[int(om1)], woffset, woffset)
		karamba.moveImage(widget, m1[int(output[3])], 40+xoffset, yoffset)
		om1 = output[3]
		
		karamba.moveImage(widget, m2[int(om2)], woffset, woffset)
		karamba.moveImage(widget, m2[int(output[4])], 58+xoffset, yoffset)
		om2 = output[4]
		
		karamba.moveImage(widget, s1[int(os1)], woffset, woffset)
		karamba.moveImage(widget, s1[int(output[6])], 80+xoffset, yoffset)
		os1 = output[6]
		
		karamba.moveImage(widget, s2[int(os2)], woffset, woffset)
		karamba.moveImage(widget, s2[int(output[7])], 98+xoffset, yoffset)
		os2 = output[7]
		
		karamba.redrawWidget(widget)


def widgetClicked(widget, x, y, button):
	pass

def widgetMouseMoved(widget, x, y, button):
	pass
#	global tooltip
#	karamba.addImageTooltip(widget, images[image], tooltip)

# This will be printed when the widget loads.
print "Loaded TubeClock python extension!" 

 
