#!/usr/bin/perl

$cpu = cat("/proc/cpuinfo");
$cpu =~ /(.*cpu MHz.*)/;
@cpumhz = split/:/,$1;
$cpumhz = sprintf ("%.f",$cpumhz[1]);
print "cpu @ ". $cpumhz ." Mhz\n";

$net = `/sbin/ifconfig eth0 | grep 'inet addr'`;
chop($net);
@netip = split/:/,$net;
$netip[1] =~ /(\d{1,3}).(\d{1,3}).(\d{1,3}).(\d{1,3})/;
$ip = $1 .".". $2 .".". $3 .".". $4;
print "ip: ". $ip ."\n";

$packet_in = `cat /proc/net/dev | grep eth0 | awk -F: '/:/ {print \$2}' | awk '{printf \$1}'`;
if($packet_in < 1024**3) { $packet_in = sprintf("%.02f",$packet_in / 1024**2)." Mb"; } else { $packet_in = sprintf("%.02f", $packet_in / 1024**3)." Gb"; }
print $packet_in ."\n";

$packet_out = `cat /proc/net/dev | grep eth0 | awk -F: '/:/ {print \$2}' | awk '{print \$9}'`;
if($packet_out < 1024**3) { $packet_out = sprintf("%.02f",$packet_out / 1024**2)." Mb"; } else { $packet_out = sprintf("%.02f", $packet_out / 1024**3)." Gb"; }
print $packet_out ."\n";

sub cat {
	my @file;
	open MYFILE, $_[0] or die "$!";
	@file = <MYFILE>;
	close MYFILE;
	return (wantarray) ? @file : join("",  @file);
}

