#!/bin/sh
#Author : Lyudmil Vladimirov Antonov
#Note: You can freely change and redistribute this program as long as the first three lines stays the same i.e. my name is on it
#numeric for current rate of change
if (( $1 == 1 ))
then
	chargin=(`cat /proc/acpi/battery/BAT1/state | grep charging| cut -d : -f2`)
	remain=(`cat /proc/acpi/battery/BAT1/state | grep rate| cut -d : -f2`)
	if [[ ${chargin[0]} == "charging" ]]
	then
		echo +${remain[0]}
	fi
	
	if [[ ${chargin[0]} == "discharging" ]]
	then
		echo -${remain[0]}
	fi
fi

if (( $1 == -1 ))
then
	chargin=(`cat /proc/acpi/battery/BAT1/state | grep charging| cut -d : -f2`)
	remain=(`cat /proc/acpi/battery/BAT1/state | grep rate| cut -d : -f2`)
	if [[ ${chargin[0]} == "charging" ]]
	then
		echo -${remain[0]}
	fi
	
	if [[ ${chargin[0]} == "discharging" ]]
	then
		echo +${remain[0]}
	fi
fi


#numeric for remaining charge
if (( $1 == 2 ))
then
	remain=(`cat /proc/acpi/battery/BAT1/state | grep remain| cut -d : -f2`)
	echo ${remain[0]}
fi

#remain vs capacity
if (( $1 == 3 ))
then
	remain=(`cat /proc/acpi/battery/BAT1/state | grep remain| cut -d : -f2`)
    capall=(`cat /proc/acpi/battery/BAT1/info | grep last| cut -d : -f2`)
	echo ${remain[0]}${remain[1]} / ${capall[0]}${capall[1]}
fi

#rate with a sign depending on whether the battery is chargin
if (( $1 == 4 ))
then
	chargin=(`cat /proc/acpi/battery/BAT1/state | grep charging| cut -d : -f2`)
	remain=(`cat /proc/acpi/battery/BAT1/state | grep rate| cut -d : -f2`)
	if [[ ${chargin[0]} == "charging" ]]
	then
		echo +${remain[0]}${remain[1]}
	fi
	
	if [[ ${chargin[0]} == "discharging" ]]
	then
		echo -${remain[0]}${remain[1]}
	fi

fi

if (( $1 == -4 ))
then
	chargin=(`cat /proc/acpi/battery/BAT1/state | grep charging| cut -d : -f2`)
	remain=(`cat /proc/acpi/battery/BAT1/state | grep rate| cut -d : -f2`)
	if [[ ${chargin[0]} == "charging" ]]
	then
		echo ""
	fi
	
	if [[ ${chargin[0]} == "discharging" ]]
	then
		echo -${remain[0]}${remain[1]}
	fi

fi


